import BaseConsumer from '../../BaseGrpcConsumer';
/**
 * The IBC module provides functions for denom trace (base denom and its path)
 *
 * @group gRPC API
 *
 * @example
 * To use IBC methods, initialise a {@link ChainGrpcIbcApi} object to with a gRPC endpoint. An endpoint can be retrieved by using {@link networkEndpoints}.
 * ```ts
 * const endpoint =  getEndpointsForNetwork(Network.Devnet).grpcEndpoint;
 * const client = new ChainGrpcIbcApi(endpoint);
 * const response = await client.fetchDenomsTrace();
 * ```
 */
export declare class ChainGrpcIbcApi extends BaseConsumer {
    /**
     *
     * @param hash
     * @returns
     */
    fetchDenomTrace(hash: string): Promise<any>;
    /**
     *
     * @returns
     */
    fetchDenomsTrace(): Promise<any>;
}
