import BaseRestConsumer from '../../BaseRestConsumer';
import { AccountResponse, BaseAccountRestResponse } from '../types/custom/auth-rest';
/**
 * @group REST API
 */
export declare class ChainRestAuthApi extends BaseRestConsumer {
    /**
     * Looks up the account information for the Router address.
     *
     * @param address address of account to look up
     */
    fetchAccount(address: string): Promise<AccountResponse>;
    /**
     * Looks up the account information for any cosmos chain address.
     *
     * @param address address of account to look up
     */
    fetchCosmosAccount(address: string): Promise<BaseAccountRestResponse>;
}
